/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gebietsbaum;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gebietsbaum.boundary.AbstractGebietsgruppierungSearchParameters;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungSearch;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.business.gebietsbaum.entity.GebietsgruppierungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractGebietsgruppierungSearchView.COMPONENT_NAME)
@View(viewId = AbstractGebietsgruppierungSearchView.VIEW_ID, useCase = UseCasePermission.GEBIETSGRUPPIERUNG_SEARCH)
public abstract class AbstractGebietsgruppierungSearchView extends AbstractElectSearchView<Gebietsgruppierung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsgruppierungSearchView";
  
  public static final String VIEW_ID = "/gebietsbaum/gebietsgruppierung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractGebietsgruppierungSearchView requestHandler;

  @Inject
  private transient GebietsgruppierungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(GebietsgruppierungConversationStore.class)
  protected transient GebietsgruppierungConversationStore conversationStore;

  @Inject
  protected transient GebietsgruppierungSearch search;

  @Inject
  @ConversationGroup(AbstractGebietsgruppierungSearchParameters.class)
  protected transient GebietsgruppierungSearchParameters searchParameters;

  @Inject
  protected transient GebietsgruppierungMeta entityMeta;

  public AbstractGebietsgruppierungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Gebietsgruppierung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Gebietsgruppierung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public GebietsgruppierungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Gebietsgruppierung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Gebietsgruppierung> create();
  }

  @Override
  public List<Gebietsgruppierung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Gebietsgruppierung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onGebietsgruppierungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietsgruppierungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractGebietsgruppierungSearchView {

    @View
    @Inject
    private transient Instance<AbstractGebietsgruppierungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractGebietsgruppierungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
